import pyglet


class MenuItem(pyglet.text.Label):
    def __init__(self, callback, *args, **kwargs):
        pyglet.text.Label.__init__(self, *args, **kwargs)
        self.callback = callback


class BaseScreen(object):
    def __init__(self, screen_list):
        self.screen_list = screen_list


    def quit(self):
        self.screen_list.remove(self)


    def on_key_press(self, key, modifiers):
        if key == pyglet.window.key.ESCAPE:
            self.quit()


class MenuScreen(BaseScreen):
    def on_key_press(self, key, modifiers):
        if key in (pyglet.window.key.UP, pyglet.window.key.LEFT):
            self.selected_button -= 1
        elif key in (pyglet.window.key.DOWN, pyglet.window.key.RIGHT):
            self.selected_button += 1
        elif key == pyglet.window.key.ESCAPE:
            self.quit()
        elif key in (pyglet.window.key.LCTRL, pyglet.window.key.ENTER) and self.buttons:
            self.buttons[self.selected_button].callback()
        if self.buttons:
            self.selected_button %= len(self.buttons)

