__all__ = ['ubyte_to_value', 'byte_to_value', 'r8_to_value']

def count_bits(a, nb_bits):
     return sum(1 for b in xrange(nb_bits) if a & (1 << b))

def get_sort_func(nb_bits):
    def sort_func(a):
        return (sum(1 for b in xrange(nb_bits) if a & 1 << b) << nb_bits) + a
    return sort_func


_tmp = sorted(xrange(256), key=get_sort_func(8))
ubyte_to_value = [_tmp.index(i) for i in xrange(256)]
byte_to_value = [x - 128 for x in ubyte_to_value]
r8_to_value = [x / 256. for x in ubyte_to_value]
del _tmp
